# iiot-openapi
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 5.0.0
- Package version: 0.0.2
- Generator version: 7.12.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import iiot_openapi
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import iiot_openapi
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import iiot_openapi
from iiot_openapi.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://https:/
# See configuration.py for a list of all supported configuration parameters.
configuration = iiot_openapi.Configuration(
    host = "http://https:/"
)



# Enter a context with an instance of the API client
with iiot_openapi.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = iiot_openapi.ModelApi(api_client)
    x_auth_token = 'x_auth_token_example' # str | 
    project_id = 'project_id_example' # str | 
    create_model_request = iiot_openapi.CreateModelRequest() # CreateModelRequest | 

    try:
        # 创建模型
        api_response = api_instance.create_model(x_auth_token, project_id, create_model_request)
        print("The response of ModelApi->create_model:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ModelApi->create_model: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://https:/*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ModelApi* | [**create_model**](docs/ModelApi.md#create_model) | **POST** /v5/{project_id}/models | 创建模型
*RecordApi* | [**list_records**](docs/RecordApi.md#list_records) | **POST** /v5/{project_id}/tables/{table_id}/records/query | 查询表记录
*RecordApi* | [**save_records**](docs/RecordApi.md#save_records) | **POST** /v5/{project_id}/tables/{table_id}/records/save | 保存表记录
*TableApi* | [**create_table**](docs/TableApi.md#create_table) | **POST** /v5/{project_id}/tables | 创建表
*DefaultApi* | [**add_view_nodes**](docs/DefaultApi.md#add_view_nodes) | **POST** /v5/{project_id}/views/{view_id}/nodes/add | 添加视图节点
*DefaultApi* | [**attach_thing_to_device**](docs/DefaultApi.md#attach_thing_to_device) | **POST** /v5/{project_id}/devices/{device_id}/things | 绑定设备与实例
*DefaultApi* | [**batch_list_snapshots**](docs/DefaultApi.md#batch_list_snapshots) | **POST** /v5/{project_id}/snapshots/get | 批量查询物实例快照
*DefaultApi* | [**create_analysis_task**](docs/DefaultApi.md#create_analysis_task) | **POST** /v5/{project_id}/models/{model_id}/analysis-tasks | 创建单个分析任务
*DefaultApi* | [**create_catalog**](docs/DefaultApi.md#create_catalog) | **POST** /v5/{project_id}/catalogs | 创建目录
*DefaultApi* | [**create_device**](docs/DefaultApi.md#create_device) | **POST** /v5/{project_id}/devices | 创建设备
*DefaultApi* | [**create_dictionary**](docs/DefaultApi.md#create_dictionary) | **POST** /v5/{project_id}/dictionaries | 创建字典
*DefaultApi* | [**create_thing**](docs/DefaultApi.md#create_thing) | **POST** /v5/{project_id}/things | 
*DefaultApi* | [**create_view**](docs/DefaultApi.md#create_view) | **POST** /v5/{project_id}/views | 创建视图
*DefaultApi* | [**delete_analysis_task**](docs/DefaultApi.md#delete_analysis_task) | **DELETE** /v5/{project_id}/models/{model_id}/analysis-tasks/{task_id} | 删除单个分析任务
*DefaultApi* | [**delete_catalog**](docs/DefaultApi.md#delete_catalog) | **DELETE** /v5/{project_id}/catalogs/{catalog_id} | 删除目录
*DefaultApi* | [**delete_device**](docs/DefaultApi.md#delete_device) | **DELETE** /v5/{project_id}/devices/{device_id} | 删除指定设备
*DefaultApi* | [**delete_dictionary**](docs/DefaultApi.md#delete_dictionary) | **DELETE** /v5/{project_id}/dictionaries/{dic_id} | 删除字典
*DefaultApi* | [**delete_model**](docs/DefaultApi.md#delete_model) | **DELETE** /v5/{project_id}/models/{model_id} | 删除模型
*DefaultApi* | [**delete_records**](docs/DefaultApi.md#delete_records) | **POST** /v5/{project_id}/tables/{table_id}/records/delete | 删除表记录
*DefaultApi* | [**delete_table**](docs/DefaultApi.md#delete_table) | **DELETE** /v5/{project_id}/tables/{table_id} | 删除表
*DefaultApi* | [**delete_thing**](docs/DefaultApi.md#delete_thing) | **DELETE** /v5/{project_id}/things/{thing_id} | 
*DefaultApi* | [**delete_view**](docs/DefaultApi.md#delete_view) | **DELETE** /v5/{project_id}/views/{view_id} | 删除视图
*DefaultApi* | [**delete_view_nodes**](docs/DefaultApi.md#delete_view_nodes) | **POST** /v5/{project_id}/views/{view_id}/nodes/delete | 删除视图节点
*DefaultApi* | [**detach_device_and_thing**](docs/DefaultApi.md#detach_device_and_thing) | **DELETE** /v5/{project_id}/devices/{device_id}/things/{thing_id} | 删除设备与实例绑定关系
*DefaultApi* | [**generate_token**](docs/DefaultApi.md#generate_token) | **POST** /v1/iotstage/auth/tokens | 获取认证 Token
*DefaultApi* | [**get_model**](docs/DefaultApi.md#get_model) | **GET** /v5/{project_id}/models/{model_id} | 查询单个模型内容
*DefaultApi* | [**get_thing**](docs/DefaultApi.md#get_thing) | **GET** /v5/{project_id}/things/{thing_id} | 
*DefaultApi* | [**get_thing_properties**](docs/DefaultApi.md#get_thing_properties) | **POST** /v5/{project_id}/things/{thing_id}/properties/get | 获取单个实例关联的设备属性值
*DefaultApi* | [**get_view_data**](docs/DefaultApi.md#get_view_data) | **GET** /v5/{project_id}/views/{view_id}/data | 查询视图数据
*DefaultApi* | [**list_analysis_task_page**](docs/DefaultApi.md#list_analysis_task_page) | **GET** /v5/{project_id}/analysis-tasks | 根据条件查询分析任务列表
*DefaultApi* | [**list_analysis_tasks**](docs/DefaultApi.md#list_analysis_tasks) | **GET** /v5/{project_id}/models/{model_id}/analysis-tasks | 查询模型下分析任务列表
*DefaultApi* | [**list_catalogs**](docs/DefaultApi.md#list_catalogs) | **GET** /v5/{project_id}/catalogs | 查询目录列表
*DefaultApi* | [**list_devices**](docs/DefaultApi.md#list_devices) | **GET** /v5/{project_id}/devices | 查询设备列表
*DefaultApi* | [**list_dictionaries**](docs/DefaultApi.md#list_dictionaries) | **GET** /v5/{project_id}/dictionaries | 查询字典列表
*DefaultApi* | [**list_models**](docs/DefaultApi.md#list_models) | **GET** /v5/{project_id}/models | 分页查询模型列表
*DefaultApi* | [**list_tables**](docs/DefaultApi.md#list_tables) | **GET** /v5/{project_id}/tables | 查询表列表
*DefaultApi* | [**list_thing_snapshot**](docs/DefaultApi.md#list_thing_snapshot) | **GET** /v5/{project_id}/things/{thing_id}/snapshot | 查询物实例快照
*DefaultApi* | [**list_things**](docs/DefaultApi.md#list_things) | **GET** /v5/{project_id}/things | 
*DefaultApi* | [**list_things_in_device**](docs/DefaultApi.md#list_things_in_device) | **GET** /v5/{project_id}/devices/{device_id}/things | 获取指定设备下实例列表
*DefaultApi* | [**list_views**](docs/DefaultApi.md#list_views) | **GET** /v5/{project_id}/views | 查询视图列表
*DefaultApi* | [**modify_view_nodes**](docs/DefaultApi.md#modify_view_nodes) | **POST** /v5/{project_id}/views/{view_id}/nodes/modify | 修改视图节点
*DefaultApi* | [**query_time_series**](docs/DefaultApi.md#query_time_series) | **POST** /v5/{project_id}/things/{thing_id}/time-series/query | 查询 Thing 的属性历史值
*DefaultApi* | [**report_to_api_datasource**](docs/DefaultApi.md#report_to_api_datasource) | **POST** /v5/{project_id}/datasources/{datasource_id}/data | 
*DefaultApi* | [**set_thing_properties**](docs/DefaultApi.md#set_thing_properties) | **POST** /v5/{project_id}/things/{thing_id}/properties/set | 设置物实例关联的设备属性
*DefaultApi* | [**show_analysis_task**](docs/DefaultApi.md#show_analysis_task) | **GET** /v5/{project_id}/models/{model_id}/analysis-tasks/{task_id} | 查询单个分析任务信息
*DefaultApi* | [**show_catalog**](docs/DefaultApi.md#show_catalog) | **GET** /v5/{project_id}/catalogs/{catalog_id} | 查询目录详情
*DefaultApi* | [**show_device**](docs/DefaultApi.md#show_device) | **GET** /v5/{project_id}/devices/{device_id} | 获取指定设备
*DefaultApi* | [**show_dictionary**](docs/DefaultApi.md#show_dictionary) | **GET** /v5/{project_id}/dictionaries/{dic_id} | 查询字典详情
*DefaultApi* | [**show_table**](docs/DefaultApi.md#show_table) | **GET** /v5/{project_id}/tables/{table_id} | 查询表详情
*DefaultApi* | [**show_view**](docs/DefaultApi.md#show_view) | **GET** /v5/{project_id}/views/{view_id} | 查询视图详情
*DefaultApi* | [**show_view_nodes**](docs/DefaultApi.md#show_view_nodes) | **POST** /v5/{project_id}/views/{view_id}/nodes/query | 查询视图节点
*DefaultApi* | [**sync_records**](docs/DefaultApi.md#sync_records) | **GET** /v5/{project_id}/tables/{table_id}/records/sync | 同步表记录
*DefaultApi* | [**update_analysis_task**](docs/DefaultApi.md#update_analysis_task) | **PUT** /v5/{project_id}/models/{model_id}/analysis-tasks/{task_id} | 更新单个分析任务信息
*DefaultApi* | [**update_catalog**](docs/DefaultApi.md#update_catalog) | **PUT** /v5/{project_id}/catalogs/{catalog_id} | 修改目录
*DefaultApi* | [**update_catalogs**](docs/DefaultApi.md#update_catalogs) | **PUT** /v5/{project_id}/catalogs | 批量修改目录
*DefaultApi* | [**update_device**](docs/DefaultApi.md#update_device) | **PUT** /v5/{project_id}/devices/{device_id} | 修改指定设备
*DefaultApi* | [**update_dictionary**](docs/DefaultApi.md#update_dictionary) | **PUT** /v5/{project_id}/dictionaries/{dic_id} | 修改字典
*DefaultApi* | [**update_model**](docs/DefaultApi.md#update_model) | **PUT** /v5/{project_id}/models/{model_id} | 修改模型
*DefaultApi* | [**update_table**](docs/DefaultApi.md#update_table) | **PUT** /v5/{project_id}/tables/{table_id} | 修改表
*DefaultApi* | [**update_thing**](docs/DefaultApi.md#update_thing) | **PUT** /v5/{project_id}/things/{thing_id} | 
*DefaultApi* | [**update_view**](docs/DefaultApi.md#update_view) | **PUT** /v5/{project_id}/views/{view_id} | 修改视图


## Documentation For Models

 - [AddViewNodesReq](docs/AddViewNodesReq.md)
 - [AgingSettings](docs/AgingSettings.md)
 - [AnalysisTask](docs/AnalysisTask.md)
 - [AnalysisTaskListRsp](docs/AnalysisTaskListRsp.md)
 - [AttachThingReqDTO](docs/AttachThingReqDTO.md)
 - [AuthInfoDTO](docs/AuthInfoDTO.md)
 - [BatchListThingSnapshotsReq](docs/BatchListThingSnapshotsReq.md)
 - [BatchListThingSnapshotsReqThingsInner](docs/BatchListThingSnapshotsReqThingsInner.md)
 - [BatchListThingSnapshotsResp](docs/BatchListThingSnapshotsResp.md)
 - [BatchListThingSnapshotsRespThingsInner](docs/BatchListThingSnapshotsRespThingsInner.md)
 - [BriefAnalysisTask](docs/BriefAnalysisTask.md)
 - [BriefDictionary](docs/BriefDictionary.md)
 - [BriefModel](docs/BriefModel.md)
 - [BriefProcessSettings](docs/BriefProcessSettings.md)
 - [BriefTable](docs/BriefTable.md)
 - [BriefThing](docs/BriefThing.md)
 - [BriefView](docs/BriefView.md)
 - [Catalog](docs/Catalog.md)
 - [CatalogNode](docs/CatalogNode.md)
 - [CatalogOrder](docs/CatalogOrder.md)
 - [CleanAnalysisSettingsDto](docs/CleanAnalysisSettingsDto.md)
 - [CleanSettings](docs/CleanSettings.md)
 - [ColumnSchema](docs/ColumnSchema.md)
 - [ComplexAnalysisSettingsDto](docs/ComplexAnalysisSettingsDto.md)
 - [ComplexSetting](docs/ComplexSetting.md)
 - [ComponentDto](docs/ComponentDto.md)
 - [ComponentProperty](docs/ComponentProperty.md)
 - [ComponentReferenceConfDetails](docs/ComponentReferenceConfDetails.md)
 - [CreateAnalysisTaskReq](docs/CreateAnalysisTaskReq.md)
 - [CreateCatalogReq](docs/CreateCatalogReq.md)
 - [CreateDeviceReqDTO](docs/CreateDeviceReqDTO.md)
 - [CreateDeviceRespDTO](docs/CreateDeviceRespDTO.md)
 - [CreateDictionaryReq](docs/CreateDictionaryReq.md)
 - [CreateModelRequest](docs/CreateModelRequest.md)
 - [CreateTableRequest](docs/CreateTableRequest.md)
 - [CreateThingRequest](docs/CreateThingRequest.md)
 - [CreateTokenReqDTO](docs/CreateTokenReqDTO.md)
 - [CreateViewReq](docs/CreateViewReq.md)
 - [DataList](docs/DataList.md)
 - [DataSchema](docs/DataSchema.md)
 - [DatasourceReportRequest](docs/DatasourceReportRequest.md)
 - [DatasourceReportResponse](docs/DatasourceReportResponse.md)
 - [DeleteRecordsRequest](docs/DeleteRecordsRequest.md)
 - [DeleteViewNodesReq](docs/DeleteViewNodesReq.md)
 - [DeviceDTO](docs/DeviceDTO.md)
 - [DicItem](docs/DicItem.md)
 - [Dictionary](docs/Dictionary.md)
 - [DoubleSchema](docs/DoubleSchema.md)
 - [EnrichedCatalogNode](docs/EnrichedCatalogNode.md)
 - [EnrichedThingNode](docs/EnrichedThingNode.md)
 - [EventGenAnalysisSettingsDto](docs/EventGenAnalysisSettingsDto.md)
 - [EventGenExpression](docs/EventGenExpression.md)
 - [EventGenOutput](docs/EventGenOutput.md)
 - [EventGenSetting](docs/EventGenSetting.md)
 - [EventOutputExpression](docs/EventOutputExpression.md)
 - [EventTrigger](docs/EventTrigger.md)
 - [Expression](docs/Expression.md)
 - [ExpressionAnalysisSettingsDto](docs/ExpressionAnalysisSettingsDto.md)
 - [ExpressionSettings](docs/ExpressionSettings.md)
 - [GetDeviceRespDTO](docs/GetDeviceRespDTO.md)
 - [ITStatReports](docs/ITStatReports.md)
 - [IndexSchema](docs/IndexSchema.md)
 - [IntegerSchema](docs/IntegerSchema.md)
 - [IntegratedReports](docs/IntegratedReports.md)
 - [ListAnalysisTaskPageRsp](docs/ListAnalysisTaskPageRsp.md)
 - [ListCatalogsResp](docs/ListCatalogsResp.md)
 - [ListDevicesDTO](docs/ListDevicesDTO.md)
 - [ListDictionariesResp](docs/ListDictionariesResp.md)
 - [ListModelsResp](docs/ListModelsResp.md)
 - [ListRecordsRequest](docs/ListRecordsRequest.md)
 - [ListSnapshotResp](docs/ListSnapshotResp.md)
 - [ListTablesResp](docs/ListTablesResp.md)
 - [ListThingsResp](docs/ListThingsResp.md)
 - [ListViewsResp](docs/ListViewsResp.md)
 - [MarkerTableRecords](docs/MarkerTableRecords.md)
 - [Model](docs/Model.md)
 - [ModifyCatalogNode](docs/ModifyCatalogNode.md)
 - [ModifyViewNodesReq](docs/ModifyViewNodesReq.md)
 - [ObjectSchema](docs/ObjectSchema.md)
 - [OriginalReports](docs/OriginalReports.md)
 - [OtstatReports](docs/OtstatReports.md)
 - [PageInfo](docs/PageInfo.md)
 - [Project](docs/Project.md)
 - [PropGenOutput](docs/PropGenOutput.md)
 - [PropOutputExpression](docs/PropOutputExpression.md)
 - [PropertiesGetReq](docs/PropertiesGetReq.md)
 - [PropertiesGetResp](docs/PropertiesGetResp.md)
 - [PropertiesSetResp](docs/PropertiesSetResp.md)
 - [PropertyDto](docs/PropertyDto.md)
 - [PropertyRef](docs/PropertyRef.md)
 - [PropertyValue](docs/PropertyValue.md)
 - [PropertyValueObject](docs/PropertyValueObject.md)
 - [PropertyValueTime](docs/PropertyValueTime.md)
 - [PropertyValues](docs/PropertyValues.md)
 - [QueryViewNodesReq](docs/QueryViewNodesReq.md)
 - [QueryViewNodesRsp](docs/QueryViewNodesRsp.md)
 - [RecordFilter](docs/RecordFilter.md)
 - [ReferenceConfDetails](docs/ReferenceConfDetails.md)
 - [ReportDevice](docs/ReportDevice.md)
 - [SaveRecordsRequest](docs/SaveRecordsRequest.md)
 - [ServiceData](docs/ServiceData.md)
 - [StringSchema](docs/StringSchema.md)
 - [SubEventGenSetting](docs/SubEventGenSetting.md)
 - [SubEventPropSetting](docs/SubEventPropSetting.md)
 - [TableInfo](docs/TableInfo.md)
 - [TableRecords](docs/TableRecords.md)
 - [TableRef](docs/TableRef.md)
 - [TableSchema](docs/TableSchema.md)
 - [TagMatcher](docs/TagMatcher.md)
 - [Thing](docs/Thing.md)
 - [ThingDTO](docs/ThingDTO.md)
 - [ThingListDTO](docs/ThingListDTO.md)
 - [ThingNode](docs/ThingNode.md)
 - [TimeSeriesQueryRequest](docs/TimeSeriesQueryRequest.md)
 - [TimeSeriesQueryResponse](docs/TimeSeriesQueryResponse.md)
 - [TimeSpan](docs/TimeSpan.md)
 - [Token](docs/Token.md)
 - [UpdateAnalysisTaskReq](docs/UpdateAnalysisTaskReq.md)
 - [UpdateCatalogReq](docs/UpdateCatalogReq.md)
 - [UpdateCatalogsReq](docs/UpdateCatalogsReq.md)
 - [UpdateCatalogsResp](docs/UpdateCatalogsResp.md)
 - [UpdateColumnSchema](docs/UpdateColumnSchema.md)
 - [UpdateDeviceDTO](docs/UpdateDeviceDTO.md)
 - [UpdateDictionaryReq](docs/UpdateDictionaryReq.md)
 - [UpdateModelReq](docs/UpdateModelReq.md)
 - [UpdateTableRequest](docs/UpdateTableRequest.md)
 - [UpdateTableSchema](docs/UpdateTableSchema.md)
 - [UpdateThingRequest](docs/UpdateThingRequest.md)
 - [UpdateViewReq](docs/UpdateViewReq.md)
 - [View](docs/View.md)
 - [ViewData](docs/ViewData.md)
 - [ViewLevel](docs/ViewLevel.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




